/*
 * GPI Argentina S.A
 * La Plata - Buenos Aires - Argentina
 * http://www.gpi.com.ar
 * Author: "Cesar Vargas"
 * Date:  02/06/2010 - 10:53:24
 */
package org.hornetq.jms.example;

import javax.jms.DeliveryMode;
import javax.jms.Destination;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.TextMessage;

import org.apache.log4j.Logger;

/**
 * @author "Cesar Vargas"
 * 
 */
public class SimpleConsumerServer extends AbstractConnectionConsumer  {

	/**
	 * logger
	 */
	static Logger logger = Logger.getLogger(SimpleConsumerServer.class);

	/**
	 * @param discoveryAddress
	 * @param discoveryPort
	 */
	public SimpleConsumerServer(String discoveryAddress, int discoveryPort) {
		super(discoveryAddress, discoveryPort);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see javax.jms.MessageListener#onMessage(javax.jms.Message)
	 */
	public void onMessage(final Message request) {
		try {
			// Cuenta cantidad de mensajes recibidos
			count();
			// Extrae el destination para enviar la respuesta
			Destination replyDestination = request.getJMSReplyTo();
			// Crea el mensaje de respuesta
			TextMessage replyMessage = session.createTextMessage("A reply message");
			logger.info("Cantidad de mensajes: " + countsTotal);
			// Setea el correlationID utilizando el messageID
			replyMessage.setJMSCorrelationID(request.getJMSMessageID());
			// Envia la respuesta
			replyProducer.send(replyDestination, replyMessage);

		} catch (JMSException e) {
			logger.error("Error en el On Mesaje", e);
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.hornetq.jms.example.AbstractConnectionConsumer#createReplyProducer()
	 */
	public void createReplyProducer() throws JMSException {
		replyProducer = session.createProducer(null);
		replyProducer.setDeliveryMode(DeliveryMode.NON_PERSISTENT);
	}

}
